<?php
	if(!function_exists('wuoc_sanitize_data')){
		function wuoc_sanitize_data( $input ) {
			if(is_array($input)){		
				$new_input = array();	
				foreach ( $input as $key => $val ) {
					$new_input[ $key ] = (is_array($val)?wuoc_sanitize_data($val):sanitize_text_field( $val ));
				}			
			}else{
				$new_input = sanitize_text_field($input);			
				if(stripos($new_input, '@') && is_email($new_input)){
					$new_input = sanitize_email($new_input);
				}
				if(stripos($new_input, 'http') || wp_http_validate_url($new_input)){
					$new_input = esc_url($new_input);
				}			
			}	
			return $new_input;
		}	
	}
	
	if(!function_exists('wuoc_pre')){
	function wuoc_pre($data){
			if(isset($_GET['debug'])){
				wuoc_pree($data);
			}
		}	 
	} 	
	if(!function_exists('wuoc_pree')){
	function wuoc_pree($data){
				echo '<pre>';
				print_r($data);
				echo '</pre>';	
		
		}	 
	} 
	if(!function_exists('wuoc_admin_menu')){
		function wuoc_admin_menu()
		{
			global $wuoc_data;
			$title = str_replace('WooCommerce', 'WC', $wuoc_data['Name']);
			add_submenu_page('woocommerce', $title, __('Orders Combination', 'woo-uoc'), 'manage_options', 'wuoc-settings', 'wuoc_settings' );
	
		}
		add_action( 'admin_menu', 'wuoc_admin_menu' );
		
	}
	if(!function_exists('wuoc_plugin_linx')){
		function wuoc_plugin_linx($links) { 

			global $wuoc_premium_copy, $wuoc_pro;
			$settings_link = '<a href="admin.php?page=wuoc-settings">'.__('Settings', 'woo-uoc').'</a>';
			if($wuoc_pro){
				array_unshift($links, $settings_link); 
			}else{
				$wuoc_premium_link = '<a href="'.esc_url($wuoc_premium_copy).'" title="'.__('Go Premium', 'woo-uoc').'" target="_blank">'.__('Go Premium', 'woo-uoc').'</a>'; 
				array_unshift($links, $settings_link, $wuoc_premium_link); 
			}
			return $links; 
		}
	}